
/*
 * Name: Bhaskar S
 * 
 * Date: 10/10/2009 
 */

package com.polarsparc.jdk.compiler;

import java.util.*;
import java.io.*;
import java.net.*;

import javax.tools.*;
import javax.tools.JavaCompiler.CompilationTask;

public class StringCompile {
	public static void main(String[] args) {
		try {
			JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
			
			StandardJavaFileManager manager = compiler.getStandardFileManager(null, null, null);
			
			JavaFileObject strFile = new StringJavaFileObject("com.polarsparc.jdk.compiler.FilterEven", generateJavaCode());
			
			Iterable<? extends JavaFileObject> units = Arrays.asList(strFile);
			
			String[] opts = new String[] { "-d", "classes" };
			
			CompilationTask task = compiler.getTask(null, manager, null, Arrays.asList(opts), null, units);
			boolean status = task.call();
			if (status) {
				System.out.printf("Compilation successful!!!\n");
				
				File classesDir = new File("classes");
				URL[] classpath = new URL[] { classesDir.toURI().toURL() };
				URLClassLoader urlClassloader = new URLClassLoader(classpath, StringCompile.class.getClassLoader());
				Class<?> clazz = urlClassloader.loadClass("com.polarsparc.jdk.compiler.FilterEven");
				Filter filter = (Filter) clazz.newInstance();
				if (filter.filter(10)) {
					System.out.println("10 is an even number");
				}
				if (filter.filter(15) == false) {
					System.out.println("15 is an odd number");
				}
			}
			else {
				System.out.printf("***** Compilation failed!!!\n");
			}
		}
		catch (Exception ex) {
			ex.printStackTrace(System.err);
			System.exit(1);
		}
	}
	
	private static String generateJavaCode() {
		StringBuilder sb = new StringBuilder();
		sb.append("package com.polarsparc.jdk.compiler;");
		sb.append("public class FilterEven implements Filter {");
		sb.append("   @Override");
		sb.append("   public boolean filter(int num) {");
		sb.append("      if (num % 2 == 0) {");
		sb.append("         return true;");
		sb.append("      }");
		sb.append("      return false;");
		sb.append("   }");
		sb.append("}");
		return sb.toString();
	}
}
